use htmlgenerator::errors::*;
use htmlgenerator::blocks::*;
use randomquote::get_quote;
use rocket::fs::FileServer;
use rocket::response::content::RawHtml;

mod htmlgenerator;
mod randomquote;

#[macro_use] extern crate rocket;

//TODO replace with file/env configuration
fn get_links() -> Vec<(&'static str, &'static str)>{
    Vec::from([
        ("/", "/home"),
        ("/gallery", "/gallery"),
        ("https://git.banii.cafe", "/repos"),
        ("https://github.com/genki-angel", ">github")
    ])
}

#[get("/")]
fn index() -> RawHtml<String> {
    RawHtml(htmlgenerator::builder::build_page(
        gen_head("UTF-8", "genki_angel", "banii.cafe", "base"), 
        gen_header("BANII.CAFE", get_quote()), 
        gen_main(gen_nav(get_links()), home_content()), 
        gen_footer()
    ))
}

#[get("/gallery")]
fn gallery()-> RawHtml<String> {
    RawHtml(htmlgenerator::builder::build_page(
        gen_head("UTF-8", "genki_angel", "banii.cafe", "base"), 
        gen_header("BANII.CAFE", "under construction!".to_string()), 
        gen_main(gen_nav(get_links()), gen_placeholder()), 
        gen_footer()
    ))
}

#[launch]
fn rocket() -> _ {
    rocket::build()
    .register("/", catchers![default])
    .mount("/", routes![index, gallery])
    .mount("/", FileServer::from("./static"))
}
